Package com.saxonica.ee.jaxp

## Class ValidatorHandlerImpl

- java.lang.Object
- - javax.xml.validation.ValidatorHandler
  - - com.saxonica.ee.jaxp.ValidatorHandlerImpl

- All Implemented Interfaces:
    `org.xml.sax.ContentHandler`, `org.xml.sax.DTDHandler`, `org.xml.sax.ext.LexicalHandler`

      public class ValidatorHandlerImpl
      extends javax.xml.validation.ValidatorHandler
      implements org.xml.sax.ContentHandler, org.xml.sax.ext.LexicalHandler, org.xml.sax.DTDHandler

  The is the Saxon implementation of the JAXP 1.3 ValidatorHandler interface. It is a SAX ContentHandler that accepts events from an XML parser (or elsewhere), validates them, reports any errors, and passes the events on to another ContentHandler. The events that are passed on will be augmented with extra elements and attributes that expand default values defined in the schema. In addition, the receiving ContentHandler has access to a TypeInfoProvider that gives information about the type of the current element or attribute event.

  A ValidatorHandler is the front end to a rather complex pipeline. The ValidatorHandler is the first stage in the pipeline: it receives events from a SAX parser or other source of SAX events. The next stage is a ReceivingContentHandler, which translates SAX events into Receiver events. This is followed by a number of Receivers to do the validation (actually a stack of Receivers, since a new ComplexContentValidator is added each time a new element starts). The last Receiver is the finalProxy: this translates Receiver events back into SAX2 events, for delivery to the user's ContentHandler.

  The user's ContentHandler has access to a TypeInfoProvider that gives information about the types of elements and attributes. This information is passed down the Receiver pipeline in the form of typeCodes associated with element and attribute events. The TypeInfoProvider is part of the finalProxy, which saves the type information locally and returns it to the user's ContentHandler on request. The TypeInfo objects supplied by the TypeInfoProvider are in fact the schema components representing the type, as a SchemaType object.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ValidatorHandlerImpl()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `characters​(char[] ch, int start, int length)` | Receive notification of character data.
    `void` | `comment​(char[] ch, int start, int length)` | Report an XML comment anywhere in the document.
    `void` | `endCDATA()` | Report the end of a CDATA section.
    `void` | `endDocument()` | Receive notification of the end of a document.
    `void` | `endDTD()` | Report the end of DTD declarations.
    `void` | `endElement​(java.lang.String uri, java.lang.String localName, java.lang.String qName)` | Receive notification of the end of an element.
    `void` | `endEntity​(java.lang.String name)` | Report the end of an entity.
    `void` | `endPrefixMapping​(java.lang.String prefix)` | End the scope of a prefix-URI mapping.
    `EnterpriseConfiguration` | `getConfiguration()` | Get the Configuration object
    `org.xml.sax.ContentHandler` | `getContentHandler()` | Gets the `ContentHandler` which receives the augmented validation result.
    `org.xml.sax.ErrorHandler` | `getErrorHandler()` | Gets the current `ErrorHandler`
    `java.lang.Object` | `getProperty​(java.lang.String name)` | Look up the value of a property.
    `org.w3c.dom.ls.LSResourceResolver` | `getResourceResolver()` | Gets the current `LSResourceResolver`
    `javax.xml.validation.TypeInfoProvider` | `getTypeInfoProvider()` | Obtains the `TypeInfoProvider` implementation of this `ValidatorHandler`.
    `void` | `ignorableWhitespace​(char[] ch, int start, int length)` | Receive notification of ignorable whitespace in element content.
    `void` | `notationDecl​(java.lang.String name, java.lang.String publicId, java.lang.String systemId)` | Receive notification of a notation declaration event.
    `void` | `processingInstruction​(java.lang.String target, java.lang.String data)` | Receive notification of a processing instruction.
    `void` | `setContentHandler​(org.xml.sax.ContentHandler receiver)` | Sets the `ContentHandler` which receives the augmented validation result.
    `void` | `setDocumentLocator​(org.xml.sax.Locator locator)` | Receive an object for locating the origin of SAX document events.
    `void` | `setErrorHandler​(org.xml.sax.ErrorHandler errorHandler)` | Sets the `ErrorHandler` to receive errors encountered during the validation.
    `void` | `setFinalProxy​(TypedContentHandler proxy)` | Set the TypedContentHandler that acts as the final stage in this pipeline, receiving typed events from the validator stack
    `void` | `setPipelineConfiguration​(PipelineConfiguration pipe)` | Set the pipeline configuration used by this validator handler
    `void` | `setProperty​(java.lang.String name, java.lang.Object object)` | Set the value of a property.
    `void` | `setReceivingContentHandler​(ReceivingContentHandler rch)` | Get the ReceivingContentHandler that receives the SAX events at the start of this pipeline
    `void` | `setResourceResolver​(org.w3c.dom.ls.LSResourceResolver resourceResolver)` | Sets the `LSResourceResolver` to customize resource resolution while in a validation episode.
    `void` | `skippedEntity​(java.lang.String name)` | Receive notification of a skipped entity.
    `void` | `startCDATA()` | Report the start of a CDATA section.
    `void` | `startDocument()` | Receive notification of the beginning of a document.
    `void` | `startDTD​(java.lang.String name, java.lang.String publicId, java.lang.String systemId)` | Report the start of DTD declarations, if any.
    `void` | `startElement​(java.lang.String uri, java.lang.String localName, java.lang.String qName, org.xml.sax.Attributes atts)` | Receive notification of the beginning of an element.
    `void` | `startEntity​(java.lang.String name)` | Report the beginning of some internal and external XML entities.
    `void` | `startPrefixMapping​(java.lang.String prefix, java.lang.String uri)` | Begin the scope of a prefix-URI Namespace mapping.
    `void` | `unparsedEntityDecl​(java.lang.String name, java.lang.String publicId, java.lang.String systemId, java.lang.String notationName)` | Receive notification of an unparsed entity declaration event.

    - ### Methods inherited from class javax.xml.validation.ValidatorHandler

      `getFeature, setFeature`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ValidatorHandlerImpl

          public ValidatorHandlerImpl()

  - ### Method Detail

    - #### setPipelineConfiguration

          public void setPipelineConfiguration​(PipelineConfiguration pipe)

      Set the pipeline configuration used by this validator handler
      Parameters:
        `pipe` - the pipeline configuration

    - #### setReceivingContentHandler

          public void setReceivingContentHandler​(ReceivingContentHandler rch)

      Get the ReceivingContentHandler that receives the SAX events at the start of this pipeline
      Parameters:
        `rch` - the ReceivingContentHandler

    - #### setFinalProxy

          public void setFinalProxy​(TypedContentHandler proxy)

      Set the TypedContentHandler that acts as the final stage in this pipeline, receiving typed events from the validator stack
      Parameters:
        `proxy` - the TypedContentHandler at the end of the pipeline

    - #### setContentHandler

          public void setContentHandler​(org.xml.sax.ContentHandler receiver)

      Sets the `ContentHandler` which receives the augmented validation result.

      A `ValidatorHandler` may buffer events to certain extent, but to allow `ValidatorHandler` to be used by a parser, the following requirement has to be met.

      1. When `ContentHandler.startElement(String, String, String, Attributes)`, `ContentHandler.endElement(String, String, String)`, `ContentHandler.startDocument()`, or `ContentHandler.endDocument()` are invoked on a `ValidatorHandler`, the same method on the user-specified `ContentHandler` must be invoked for the same event before the callback returns.

      The Saxon implementation does not meet this requirement. StartElement events are buffered until the first thing following the attributes is encountered.

      Specified by:
        `setContentHandler` in class `javax.xml.validation.ValidatorHandler`
      Parameters:
        `receiver` - A `ContentHandler` or a null value.

    - #### getContentHandler

          public org.xml.sax.ContentHandler getContentHandler()

      Gets the `ContentHandler` which receives the augmented validation result.
      Specified by:
        `getContentHandler` in class `javax.xml.validation.ValidatorHandler`
      Returns:
        This method returns the object that was last set through the `setContentHandler(org.xml.sax.ContentHandler)` method, or null if that method has never been called since this `ValidatorHandler` has created.
      See Also:
        `setContentHandler(org.xml.sax.ContentHandler)`

    - #### setErrorHandler

          public void setErrorHandler​(org.xml.sax.ErrorHandler errorHandler)

      Sets the `ErrorHandler` to receive errors encountered during the validation.
      Specified by:
        `setErrorHandler` in class `javax.xml.validation.ValidatorHandler`
      Parameters:
        `errorHandler` - A new error handler to be set. This parameter can be null.

    - #### getErrorHandler

          public org.xml.sax.ErrorHandler getErrorHandler()

      Gets the current `ErrorHandler`
      Specified by:
        `getErrorHandler` in class `javax.xml.validation.ValidatorHandler`
      Returns:
        This method returns the object that was last set through the `setErrorHandler(org.xml.sax.ErrorHandler)` method, or null if that method has never been called
      See Also:
        `setErrorHandler(org.xml.sax.ErrorHandler)`

    - #### setResourceResolver

          public void setResourceResolver​(org.w3c.dom.ls.LSResourceResolver resourceResolver)

      Sets the `LSResourceResolver` to customize resource resolution while in a validation episode.
      Specified by:
        `setResourceResolver` in class `javax.xml.validation.ValidatorHandler`
      Parameters:
        `resourceResolver` - A new resource resolver to be set. This parameter can be null.

    - #### getResourceResolver

          public org.w3c.dom.ls.LSResourceResolver getResourceResolver()

      Gets the current `LSResourceResolver`
      Specified by:
        `getResourceResolver` in class `javax.xml.validation.ValidatorHandler`
      Returns:
        This method returns the object that was last set through the `setResourceResolver(org.w3c.dom.ls.LSResourceResolver)` method, or null if that method has never been called

    - #### getTypeInfoProvider

          public javax.xml.validation.TypeInfoProvider getTypeInfoProvider()

      Obtains the `TypeInfoProvider` implementation of this `ValidatorHandler`. The obtained `TypeInfoProvider` can be queried during a parse to access the type information determined by the validator.
      Specified by:
        `getTypeInfoProvider` in class `javax.xml.validation.ValidatorHandler`
      Returns:
        A non-null valid `TypeInfoProvider`.

    - #### setDocumentLocator

          public void setDocumentLocator​(org.xml.sax.Locator locator)

      Receive an object for locating the origin of SAX document events.
      Specified by:
        `setDocumentLocator` in interface `org.xml.sax.ContentHandler`
      Parameters:
        `locator` - an object that can return the location of any SAX document event
      See Also:
        `Locator`

    - #### getProperty

          public java.lang.Object getProperty​(java.lang.String name)
                                       throws org.xml.sax.SAXNotRecognizedException,
                                              org.xml.sax.SAXNotSupportedException

      Look up the value of a property.

      The property name is any fully-qualified URI. It is possible for a `ValidatorHandler` to recognize a property name but temporarily be unable to return its value. Some property values may be available only in specific contexts, such as before, during, or after a validation.

      `Validator`s are not required to recognize any specific property names.

      In the Saxon implementation, the property names that are recognized are the same as the attribute names recognised by a `TransformerFactory`. These are listed as constant fields in the class `FeatureKeys`

      Overrides:
        `getProperty` in class `javax.xml.validation.ValidatorHandler`
      Parameters:
        `name` - The property name, which is a non-null fully-qualified URI.
      Returns:
        The current value of the property.
      Throws:
        `org.xml.sax.SAXNotRecognizedException` - If the property value can't be assigned or retrieved.
        `org.xml.sax.SAXNotSupportedException` - When the XMLReader recognizes the property name but cannot determine its value at this time.
        `java.lang.NullPointerException` - When the name parameter is null.
      See Also:
        `setProperty(String, Object)`

    - #### setProperty

          public void setProperty​(java.lang.String name,
                                  java.lang.Object object)
                           throws org.xml.sax.SAXNotRecognizedException,
                                  org.xml.sax.SAXNotSupportedException

      Set the value of a property.

      The property name is any fully-qualified URI. It is possible for a `ValidatorHandler` to recognize a property name but to be unable to change the current value. Some property values may be immutable or mutable only in specific contexts, such as before, during, or after a validation.

      In the Saxon implementation, the property names that are recognized are the same as the attribute names recognised by a `TransformerFactory`. These are listed as constant fields in the class `FeatureKeys`

      Overrides:
        `setProperty` in class `javax.xml.validation.ValidatorHandler`
      Parameters:
        `name` - The property name, which is a non-null fully-qualified URI.
        `object` - The requested value for the property.
      Throws:
        `org.xml.sax.SAXNotRecognizedException` - If the property value can't be assigned or retrieved.
        `org.xml.sax.SAXNotSupportedException` - When the `Validator` recognizes the property name but cannot set the requested value.
        `java.lang.NullPointerException` - When the name parameter is null.

    - #### getConfiguration

          public EnterpriseConfiguration getConfiguration()

      Get the Configuration object
      Returns:
        the Configuration, which will always be schema-aware

    - #### startDocument

          public void startDocument()
                             throws org.xml.sax.SAXException

      Receive notification of the beginning of a document.

      The SAX parser will invoke this method only once, before any other event callbacks (except for `setDocumentLocator`).

      Specified by:
        `startDocument` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException` - any SAX exception, possibly wrapping another exception
      See Also:
        `endDocument()`

    - #### endDocument

          public void endDocument()
                           throws org.xml.sax.SAXException

      Receive notification of the end of a document.
      Specified by:
        `endDocument` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException` - any SAX exception, possibly wrapping another exception

    - #### startPrefixMapping

          public void startPrefixMapping​(java.lang.String prefix,
                                         java.lang.String uri)
                                  throws org.xml.sax.SAXException

      Begin the scope of a prefix-URI Namespace mapping.

      There should never be start/endPrefixMapping events for the "xml" prefix, since it is predeclared and immutable.

      Specified by:
        `startPrefixMapping` in interface `org.xml.sax.ContentHandler`
      Parameters:
        `prefix` - the Namespace prefix being declared. An empty string is used for the default element namespace, which has no prefix.
        `uri` - the Namespace URI the prefix is mapped to
      Throws:
        `org.xml.sax.SAXException` - the client may throw an exception during processing
      See Also:
        `endPrefixMapping(java.lang.String)`, `startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)`

    - #### endPrefixMapping

          public void endPrefixMapping​(java.lang.String prefix)
                                throws org.xml.sax.SAXException

      End the scope of a prefix-URI mapping.
      Specified by:
        `endPrefixMapping` in interface `org.xml.sax.ContentHandler`
      Parameters:
        `prefix` - the prefix that was being mapped. This is the empty string when a default mapping scope ends.
      Throws:
        `org.xml.sax.SAXException` - the client may throw an exception during processing

    - #### startElement

          public void startElement​(java.lang.String uri,
                                   java.lang.String localName,
                                   java.lang.String qName,
                                   org.xml.sax.Attributes atts)
                            throws org.xml.sax.SAXException

      Receive notification of the beginning of an element.
      Specified by:
        `startElement` in interface `org.xml.sax.ContentHandler`
      Parameters:
        `uri` - the Namespace URI, or the empty string if the element has no Namespace URI or if Namespace processing is not being performed
        `localName` - the local name (without prefix), or the empty string if Namespace processing is not being performed
        `qName` - the qualified name (with prefix), or the empty string if qualified names are not available
        `atts` - the attributes attached to the element. If there are no attributes, it shall be an empty Attributes object. The value of this object after startElement returns is undefined
      Throws:
        `org.xml.sax.SAXException` - any SAX exception, possibly wrapping another exception

    - #### endElement

          public void endElement​(java.lang.String uri,
                                 java.lang.String localName,
                                 java.lang.String qName)
                          throws org.xml.sax.SAXException

      Receive notification of the end of an element.
      Specified by:
        `endElement` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### characters

          public void characters​(char[] ch,
                                 int start,
                                 int length)
                          throws org.xml.sax.SAXException

      Receive notification of character data.
      Specified by:
        `characters` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### ignorableWhitespace

          public void ignorableWhitespace​(char[] ch,
                                          int start,
                                          int length)
                                   throws org.xml.sax.SAXException

      Receive notification of ignorable whitespace in element content.
      Specified by:
        `ignorableWhitespace` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### processingInstruction

          public void processingInstruction​(java.lang.String target,
                                            java.lang.String data)
                                     throws org.xml.sax.SAXException

      Receive notification of a processing instruction.
      Specified by:
        `processingInstruction` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### skippedEntity

          public void skippedEntity​(java.lang.String name)
                             throws org.xml.sax.SAXException

      Receive notification of a skipped entity.
      Specified by:
        `skippedEntity` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### startDTD

          public void startDTD​(java.lang.String name,
                               java.lang.String publicId,
                               java.lang.String systemId)
                        throws org.xml.sax.SAXException

      Report the start of DTD declarations, if any.
      Specified by:
        `startDTD` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### endDTD

          public void endDTD()
                      throws org.xml.sax.SAXException

      Report the end of DTD declarations.
      Specified by:
        `endDTD` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### startEntity

          public void startEntity​(java.lang.String name)
                           throws org.xml.sax.SAXException

      Report the beginning of some internal and external XML entities.
      Specified by:
        `startEntity` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### endEntity

          public void endEntity​(java.lang.String name)
                         throws org.xml.sax.SAXException

      Report the end of an entity.
      Specified by:
        `endEntity` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### startCDATA

          public void startCDATA()
                          throws org.xml.sax.SAXException

      Report the start of a CDATA section.
      Specified by:
        `startCDATA` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### endCDATA

          public void endCDATA()
                        throws org.xml.sax.SAXException

      Report the end of a CDATA section.
      Specified by:
        `endCDATA` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### comment

          public void comment​(char[] ch,
                              int start,
                              int length)
                       throws org.xml.sax.SAXException

      Report an XML comment anywhere in the document.
      Specified by:
        `comment` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### notationDecl

          public void notationDecl​(java.lang.String name,
                                   java.lang.String publicId,
                                   java.lang.String systemId)
                            throws org.xml.sax.SAXException

      Receive notification of a notation declaration event.
      Specified by:
        `notationDecl` in interface `org.xml.sax.DTDHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### unparsedEntityDecl

          public void unparsedEntityDecl​(java.lang.String name,
                                         java.lang.String publicId,
                                         java.lang.String systemId,
                                         java.lang.String notationName)
                                  throws org.xml.sax.SAXException

      Receive notification of an unparsed entity declaration event.
      Specified by:
        `unparsedEntityDecl` in interface `org.xml.sax.DTDHandler`
      Throws:
        `org.xml.sax.SAXException`